;;;; chicken-app.scm

;; Issues
;;
;; - Doesn't handle multiple document windows.
;;
;; - No Print, Save, Open, etc.

#|
;; Royally screws up the objc stuff!

(use syntax-case utf8 utf8-srfi-13 utf8-srfi-14)
(import utf8)
(import utf8-srfi-13)
(import utf8-srfi-14)
|#

(include "objc-header.scm")

;;

(define-constant +startup-file+ "~/.CHICKEN")

(define *last-result* #f)

(define (eval-scheme str doc)
  (##sys#clear-trace-buffer)
  (handle-exceptions ex
		(begin
			(set! *last-result*
				(call-with-output-string
					(lambda (o)
						(print-error-message ex o)
						(print-call-chain o) ) ) )
			#f)
    (set! *last-result*
      (with-output-to-string
				(lambda ()
					(pp (eval (with-input-from-string (conc "(begin " str "\n)") read)) ) ) ) )
    #t) )

(define (get-result)
  *last-result* )

(define (CHICKEN:startup)
	(require 'chicken-more-macros) 
  (when (file-exists? +startup-file+)
    (load +startup-file+) ) )

#;(define (idle doc)
  (void) )

#;(define (untabbify s #!optional (tabstop 8))
  (let ((len (string-length s)))
    (let loop ((i 0) (p 0) (c 0) (acc '()))
      (if (fx>= i len)
				(string-intersperse (reverse (cons (substring s p len) acc)) "")
				(let ((ch (string-ref s i)))
					(switch ch
						(#\newline
							(loop (fx+ i 1) p 0 acc) )
						(#\tab
							(let ((n (- tabstop (fxmod c tabstop))))
								(loop (fx+ i 1) (fx+ i 1) (fx+ c n)
											(cons* (make-string n #\space) (substring s p i) acc))))
						(else
							(loop (fx+ i 1) p (fx+ c 1) acc)) ) ) ) ) ) )

;;

(define-objc-classes NSFont NSString NSColor NSTextView NSTimer NSAttributedString NSError)

(let ([startup-file-loaded? #f]
			[timer-installed? #f])

	(define-objc-class SchemeDocument NSDocument (
			[#:outlet textView] ; (NSTextView*)
			[#:slot error?])

		(- ID init
			(set! @error? #t)
			(when (@ super init)
				(set! @error? #f))
			self)

		(- (NSString*) windowNibName
			@"SchemeDocument")

		(- VOID ((#:windowControllerDidLoadNib (NSWindowController*) aController))
			(let ([nsstr @""])
				(@ super #:windowControllerDidLoadNib aController)
				(unless startup-file-loaded?
					(set! startup-file-loaded? #t)
					(unless (@ self #:evalString @"(CHICKEN:startup)")
						(set! nsstr (objc:nsstring (get-result)))))
				#;(unless timer-installed?
					(set! timer-installed? #t)
					(@ NSTimer #:scheduledTimerWithTimeInterval 0.1
											#:target self
											#:selector (selector@ idle:)		; @selector(idle:)
											#:userInfo nil
											#:repeats #t))
				(@ @textView #:setFont (@ NSFont #:fontWithName @"Courier" #:size 14))
				(@ @textView #:setString nsstr)))

	  (- (NSData*) ((#:dataOfType (NSString*) aType) (#:error (NSError**) outerr))
			(let ([nsdata (@ @textView string)])
				nsdata))

		(- BOOL ((#:readFromData (NSData*) data) (#:ofType (NSString*) aType) (#:error (NSError**) outerr))
			(let ([nsstr (@ (@ NSString alloc) #:initWithData data #:encoding NSUTF8StringEncoding)])
				(if nsstr
					(begin
						; FIXME textView is NULL (#f) here!
						(@ @textView #:setString nsstr)
						#;(@ nsstr release)
						#t)
					#f)))

		(- VOID ((#:textDidChange (NSNotification*) n))
			(@ self #:updateChangeCount NSChangeDone))

		(- (NSString*) selectedString
			(let ([range (@ @textView selectedRange)])
				(if (positive? (ns:range-length range))
					(@ (@ @textView string) #:substringWithRange range)
					@"")))

		(- BOOL ((#:evalString (NSString*) str))
			(eval-scheme (objc:nsstring->string str) self))

		(- (NSString*) evalSelection
			(let ([nsstr (@ self selectedString)])
				(if (positive? (@ nsstr length))
					(begin
						(set! @error? (@ self #:evalString nsstr))
						(objc:nsstring (get-result)))
					nsstr)))

		(- VOID ((#:insertAndSelect (NSString*) nsstr))
  		(when nsstr
    		(let ([range (@ @textView selectedRange)]
    					[range2 #f])
    			(ns:range-location-set! range (+ (ns:range-location range) (ns:range-length range)))
    			(ns:range-length-set! range 0)
    			(set! range2 (ns:make-range (ns:range-location range) (@ nsstr length)))
					(@ @textView #:setSelectedRange range)
					(@ @textView #:insertText (@ @" => " #:stringByAppendingString nsstr))
					(@ @textView #:setSelectedRange range2))))

		(- (IBAction) ([#:eval ID sender])
			(@ self #:insertAndSelect (@ self evalSelection)))

		(- (IBAction) ([#:evalAndReplace ID sender])
			(let ([nsstr (@ self evalSelection)])
				(when nsstr
					(if @error?
						(@ self #:insertAndSelect nsstr)
						(let ([range (@ @textView selectedRange)])
							(@ @textView #:insertText nsstr)
							(ns:range-length-set! range (@ nsstr length))
							(@ @textView #:setSelectedRange range))))))

		#;(- VOID ((#:idle (NSTimer*) note))
		  #;(ns:log "~A is idle..." self)
			(idle self))
	) )

;;;

(ns:application-main)
